`timescale 1ns / 1ps

// VERSION 1.1

// UTILITY CODE

// subtract-by-64 module, incrementer, and subtracter

/*PJH 1/29/06
**I needed sub_64 (a subtractor which always subtracts 64) for
**video_out.v. A regular ALU/adder would work as well...
**It is only used for 10 bits right now, but I made it 16 bits wide, in case
**that's ever needed...
*/

//A subtractor that always subtracts 64. It does this by first flipping the 64
//bit, IN[6]. If IN[6] is a 1, then nothing else needs to be done. If IN[6] is
//a 0, then move left (more-significant), flipping 0s to 1s until you encounter
//a 1. Flip the 1 to a 0, then stop.

//module sub_64(IN, OUT);
//   input [15:0]  IN;
//   output [15:0] OUT;  //OUT = IN - 64
//   
//   wire [15:0]   not_in;
//   assign        not_in = ~IN;
//   
//   wire [7:0]    flipped;     //flipped tells you whether a bit flipped or not
//   wire [7:0]    selector;    //selector is the selector bits for the muxes
//   
//   assign        OUT[5:0] = IN[5:0];
//   //low-order 6 bits not touched when subtracting 64
//   assign        OUT[6] = not_in[6];  //the 64 bit always flips
//   
//   //Use xor to determine if bits were flipped or not
//   xor(flipped[0], IN[7],  OUT[7]);
//   xor(flipped[1], IN[8],  OUT[8]);
//   xor(flipped[2], IN[9],  OUT[9]);
//   xor(flipped[3], IN[10], OUT[10]);
//   xor(flipped[4], IN[11], OUT[11]);
//   xor(flipped[5], IN[12], OUT[12]);
//   xor(flipped[6], IN[13], OUT[13]);
//   xor(flipped[7], IN[14], OUT[14]);
//   
//    //Selector is 1 (flip the bit) if previous bit flipped AND previous bit
//   //was not a 1.
//   and(selector[0], flipped[0], not_in[7]);
//   and(selector[1], flipped[1], not_in[8]);
//   and(selector[2], flipped[2], not_in[9]);
//   and(selector[3], flipped[3], not_in[10]);
//   and(selector[4], flipped[4], not_in[11]);
//   and(selector[5], flipped[5], not_in[12]);
//   and(selector[6], flipped[6], not_in[13]);
//   and(selector[7], flipped[7], not_in[14]);
//   
//   //Use selector to select the flipped bit or the original bit.
//   mux_Nbit_2to1 #(1) mux7  ( .sel(not_in[6]),   .a(IN[7]),  .b(not_in[7]),  .out(OUT[7]) );
//   mux_Nbit_2to1 #(1) mux8  ( .sel(selector[0]), .a(IN[8]),  .b(not_in[8]),  .out(OUT[8]) );
//   mux_Nbit_2to1 #(1) mux9  ( .sel(selector[1]), .a(IN[9]),  .b(not_in[9]),  .out(OUT[9]) );
//   mux_Nbit_2to1 #(1) mux10 ( .sel(selector[2]), .a(IN[10]), .b(not_in[10]), .out(OUT[10]) );
//   mux_Nbit_2to1 #(1) mux11 ( .sel(selector[3]), .a(IN[11]), .b(not_in[11]), .out(OUT[11]) );
//   mux_Nbit_2to1 #(1) mux12 ( .sel(selector[4]), .a(IN[12]), .b(not_in[12]), .out(OUT[12]) );
//   mux_Nbit_2to1 #(1) mux13 ( .sel(selector[5]), .a(IN[13]), .b(not_in[13]), .out(OUT[13]) );
//   mux_Nbit_2to1 #(1) mux14 ( .sel(selector[6]), .a(IN[14]), .b(not_in[14]), .out(OUT[14]) );
//   mux_Nbit_2to1 #(1) mux15 ( .sel(selector[7]), .a(IN[15]), .b(not_in[15]), .out(OUT[15]) );
//
//endmodule // sub_64
//

module Nbit_incrementer ( in, out );
   parameter n = 1;
   
   input [n-1:0] in;
   output [n-1:0] out;

   assign         out = in + 1;
   
   
endmodule // Nbit_incrementer

module Nbit_subtracter ( a, b, difference );
   parameter n = 1;
   
   input [n-1:0]  a;
   input [n-1:0]  b;
   output [n-1:0] difference;

   assign        difference = a - b;
   
   
endmodule // Nbit_subtracter

module decoder3to8 (IN, DEC);
   output [7:0] DEC;
   input [2:0]  IN;
   assign       DEC = IN == 3'b000 ? 8'h01 :
                      IN == 3'b001 ? 8'h02 :
                      IN == 3'b010 ? 8'h04 :
                      IN == 3'b011 ? 8'h08 :
                      IN == 3'b100 ? 8'h10 :
                      IN == 3'b101 ? 8'h20 :
                      IN == 3'b110 ? 8'h40 :
                      IN == 3'b111 ? 8'h80 : 8'h00;
endmodule // decoder3to8

